import java.lang.*;
import java.util.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

class Punkt
{ protected int x, y;
  
  public Punkt(int wspX, int wspY) 
     {x = wspX; y = wspY;}
  
  public int podajX()  
   { return x;}
  
  public int podajY()  
   { return y;}       
  
  public double odleglosc(Punkt p)
   { return Math.sqrt((x-p.x)*(x-p.x)+(y-p.y)*(y-p.y)); }
 
  public void rysuj(Graphics g)
    {  Graphics2D g2D= (Graphics2D)g;
       Color pedzel =new Color(255,0,0);
       g2D.setColor(pedzel);
       g2D.fillOval(x,y,5,5);
     } 
  
  public void przesun(int dx, int dy, int a, int b)
   {x+=dx; y+=dy; 
    if (x>a || x<1) x=5;
    if (y>b || y<1) y=2;
   } 
  }

class Kwadrat extends Punkt
{ protected int dlugosc;

  public Kwadrat(int wspX, int wspY,int dl)
   { super(wspX,wspY);
     dlugosc=dl;}

  public void przesun(int dx, int dy, int a, int b)
    { super.przesun(dx,dy, a, b); //przesywanie i skalowanie
      dlugosc+=dx+dy;
      if (dlugosc > 30 || dlugosc <10) dlugosc=20;
   	}

  public void rysuj(Graphics g)
    {Graphics2D g2D=(Graphics2D)g;
     Color pedzel=new Color(0,255,0);
     g2D.setColor(pedzel);
     g2D.fillRect(x,y,dlugosc,dlugosc);
    } 
 }
 

class Figury extends JPanel
{ protected int N=6;
  protected Punkt figury[];

 public void wypelnij()
   {figury =new Punkt[N];
    for (int i=0; i<figury.length; i++)
	 { figury[i]=new Punkt(i*22,i*22);
 	    if (i<figury.length-1)
	 	figury[++i]= new Kwadrat (i*44,i*44,20);} 
   }
  
 public void polozenie()
  {	
   for (int i=0; i<figury.length-1;i++)
    {boolean p=figury[i] instanceof Kwadrat;
     System.out.println("\n"+
     p+", ze jestem kwadratem, bo jestem "+figury[i].toString()+ 	
      " ,X="+figury[i].podajX()+
      " , Y="+figury[i].podajY()+
      " , odleglosc="+figury[i].odleglosc(figury[i+1]));
    }
  }
   
 public void paintComponent(Graphics g) //przedefiniowanie metody  klasy JPanel
 	 { for (int i=0; i<figury.length; i++)   
         figury[i].rysuj(g); }  //automatyczne rysowanie albo punktu albo kwadratu
  
 public void animacja(int a, int b) 
  { int dx,dy;
    Random r=new Random();
    for (int i=0; i<figury.length; i++) 
      {  dx =r.nextInt()%10;
         dy =r.nextInt()%10;
         figury[i].przesun(dx,dy, a, b); 
      }        
  }
 }

public class Obraz4  extends JFrame            
{ protected Figury rysunek;
  
  public Obraz4()
  { super ("Obraz4");
    setSize(400,400);   
    setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    rysunek=new Figury();
    rysunek.wypelnij();
    rysunek.polozenie();
    setContentPane(rysunek);
    setVisible(true);
   }
   
  public void animacja()
    { Rectangle r=getBounds();
      rysunek.animacja(r.width,r.height);
      try
      {
       Thread.sleep(500);
       repaint();
      }
      catch(Exception e)
       {System.out.println("Blad uspienia "+e);}
    }
 

public static void main(String args[])
  { Obraz4 obraz=new Obraz4();
    while(true)
       obraz.animacja();
   }
}